| Linduino 1.3.0 Linear Technology Arduino-Compatible Demonstration Board

Functions | Variables
LTC2607.h File Reference
Digital-to-Analog Converters (DAC) » LTC2607: 16-Bit, Dual Rail-to-Rail DACs with I2C Interface

LTC2607: 16-Bit, Dual Rail-to-Rail DACs with I2C Interface. More...

## Detailed Description

LTC2607: 16-Bit, Dual Rail-to-Rail DACs with I2C Interface.

LTC2609: Quad 16-/14-/12-Bit Rail-to-Rail DACs with I²C Interface. LTC2606: 16-Bit Rail-to-Rail DACs with I²C Interface.

    The LTC2607/LTC2617/LTC2627 are dual 16-, 14- and 12-bit, 2.7V to 5.5V
    rail-to-rail voltage output DACs in a 12-lead DFN package. They have built-in
    high performance output buffers and are guaranteed monotonic.

    These parts establish new board-density benchmarks for 16- and 14-bit DACs and
    advance performance standards for output drive and load regulation in single-
    supply, voltage-output DACs.

    The parts use a 2-wire, I2C compatible serial interface. The
    LTC2607/LTC2617/LTC2627 operate in both the standard mode (clock rate of 100kHz)
    and the fast mode (clock rate of 400kHz). An asynchronous DAC update pin (LDAC)
    is also included.

    The LTC2607/LTC2617/LTC2627 incorporate a power-on reset circuit. During power-
    up, the voltage outputs rise less than 10mV above zero scale; and after power-
    up, they stay at zero scale until a valid write and update take place. The
    power-on reset circuit resets the LTC2607-1/LTC2617-1/ LTC2627-1 to mid-scale.
    The voltage outputs stay at midscale until a valid write and update takes place.

    I2C DATA FORMAT (MSB First):

           Byte #1                             Byte #2                          Byte #3                              Byte #4

    START  SA6 SA5 SA4 SA3 SA2 SA1 SA0 W SACK  C3 C2 C1 C0  A3  A2 A1 A0  SACK  D15 D14 D13 D12 D11 D10 D9 D8  SACK  D7 D6  D5  D4  D3  D2  D1  D0 SACK STOP

    SACK : Slave Acknowlege
    SAx  : I2C Address
    W    : I2C Write (0)
    R    : I2C Read  (1)
    SACK : I2C Slave Generated Acknowledge (Active Low)
    Cx   : DAC Command Code
    Ax   : DAC Address
    Dx   : DAC Data Bits
    X    : Don't care

    Example Code:

    Set DAC A to Full Scale.

        dac_code = 0x0FFFF; // Set dac code to full scale

        // Write dac code to the LTC2607 and update dac
        ack = LTC2607_write(LTC2607_I2C_GLOBAL_ADDRESS, LTC2607_WRITE_UPDATE_COMMAND, LTC2607_DAC_A, dac_code);

http://www.linear.com/product/LTC2607 http://www.linear.com/product/LTC2609 http://www.linear.com/product/LTC2606

http://www.linear.com/product/LTC2607#demoboards http://www.linear.com/product/LTC2609#demoboards http://www.linear.com/product/LTC2606#demoboards

Copyright 2018(c) Analog Devices, Inc.

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
- Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
- Neither the name of Analog Devices, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
- The use of this software may or may not infringe the patent rights of one or more patent holders. This license does not release you from the requirement that you obtain separate licenses from these patent holders to use this software.
- Use of the software either in source or binary form, must be run on or directly connected to an Analog Devices Inc. component.

THIS SOFTWARE IS PROVIDED BY ANALOG DEVICES "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ANALOG DEVICES BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, INTELLECTUAL PROPERTY RIGHTS, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Header File for LTC2607: 16-Bit, Dual Rail-to-Rail DACs with I2C Interface

Definition in file LTC2607.h.

Go to the source code of this file.

## Functions
int8_t | LTC2607_write (uint8_t i2c_address, uint8_t dac_command, uint8_t dac_address, uint16_t dac_code)
| Writes command, DAC address, and DAC code to the LTC2607. More...
uint16_t | LTC2607_voltage_to_code (float dac_voltage, float LTC2607_lsb, int32_t LTC2607_offset)
| Calculates an LTC2607 DAC code for the desired output voltage. More...
void | LTC2607_calibrate (uint16_t dac_code1, uint16_t dac_code2, float voltage1, float voltage2, float *LTC2607_lsb, int32_t *LTC2607_offset)
| Calculates the LTC2607 offset and lsb voltage given two measured voltages and their corresponding DAC codes. More...

## Macros
I2C_Addresses
#define | LTC2607_I2C_ADDRESS 0x10
| I2C address of the LTC2607. More...
#define | LTC2607_I2C_GLOBAL_ADDRESS 0x73
| LTC2607 Global I2C Address. More...
DAC Command
#define | LTC2607_WRITE_COMMAND 0x00
| Command to write to internal register of LTC2607, but not update output voltage yet. More...
#define | LTC2607_UPDATE_COMMAND 0x10
| Command to update (and power up) LTC2607. More...
#define | LTC2607_WRITE_UPDATE_COMMAND 0x30
| Command to write and update (and power up) the LTC2607. More...
#define | LTC2607_POWER_DOWN_COMMAND 0x40
| Command to power down the LTC2607. More...
DAC Address
#define | LTC2607_DAC_A 0x00
| Command (and DAC code) will modify DAC A. More...
#define | LTC2607_DAC_B 0x01
| Command (and DAC code) will modify DAC B. More...
#define | LTC2607_ALL_DACS 0x0F
| Command (and DAC code) will modify both DAC A and DAC B. More...

## Variables
const float | LTC2607_TYPICAL_lsb = 7.6295109E-5
| The LTC2607 typical least significant bit value with 5V full-scale. More...
const float | LTC2607_TYPICAL_OFFSET = 0
| The LTC2607 typical offset voltage. More...

## Function Documentation

## ◆ LTC2607_calibrate()

void LTC2607_calibrate | ( | uint16_t | dac_code1,
|  | uint16_t | dac_code2,
|  | float | voltage1,
|  | float | voltage2,
|  | float * | LTC2607_lsb,
|  | int32_t * | LTC2607_offset
| ) |  |

Calculates the LTC2607 offset and lsb voltage given two measured voltages and their corresponding DAC codes.

Prior to calling this function, write two DAC codes to the LTC2607, and measure the output voltage for each DAC code. When passed the DAC codes and measured voltages as parameters, this function calculates the calibrated lsb and offset values.

Parameters

  dac_code1 | DAC Code 1.
  dac_code2 | DAC Code 2.
  voltage1 | Measured output voltage corresponding to DAC Code 1.
  voltage2 | Measured output voltage corresponding to DAC Code 2.
  LTC2607_lsb | Overwritten with new calculated lsb voltage.
  LTC2607_offset | Overwritten with new calculated offset voltage.

Definition at line 127 of file LTC2607.cpp.

## ◆ LTC2607_voltage_to_code()

uint16_t LTC2607_voltage_to_code | ( | float | dac_voltage,
|  | float | LTC2607_lsb,
|  | int32_t | LTC2607_offset
| ) |  |

Calculates an LTC2607 DAC code for the desired output voltage.

Based on the desired output voltage, the offset, and lsb parameters, return the corresponding DAC code that should be written to the LTC2607.

Returns
  DAC code for desired output voltage

Parameters

  dac_voltage | Desired DAC output voltage.
  LTC2607_lsb | The LSB weight. Use calibrated value for best results, otherwise use typical value from datasheet.
  LTC2607_offset | The offset voltage. Use calibrated value for best results, otherwise use typical value from datasheet.

Definition at line 110 of file LTC2607.cpp.

## ◆ LTC2607_write()

int8_t LTC2607_write | ( | uint8_t | i2c_address,
|  | uint8_t | dac_command,
|  | uint8_t | dac_address,
|  | uint16_t | dac_code
| ) |  |

Writes command, DAC address, and DAC code to the LTC2607.

Configures command (write, update, power down, etc.), address (DAC A, DAC B, or BOTH), and 16-bit dac_code for output voltage.

Returns
  Returns the state of the acknowledge bit after the I2C address write. 0=acknowledge, 1=no acknowledge.

Parameters

  i2c_address | I2C address of the LTC2607. Configured by CA0, CA1, and CA2 pins. See Table 1 of datasheet.
  dac_command | DAC command (4-bits) that will be written to LTC2607. (Write, update, power down, etc.)
  dac_address | DAC address (4-bits) that will be written to LTC2607. Configures DAC A, DAC B, or both.
  dac_code | DAC code that will be written to LTC2607. This configures the output voltage.

Definition at line 100 of file LTC2607.cpp.

## Macro Definition Documentation

## ◆ LTC2607_ALL_DACS

#define LTC2607_ALL_DACS 0x0F

Command (and DAC code) will modify both DAC A and DAC B.

Definition at line 163 of file LTC2607.h.

## ◆ LTC2607_DAC_A

#define LTC2607_DAC_A 0x00

Command (and DAC code) will modify DAC A.

Definition at line 161 of file LTC2607.h.

## ◆ LTC2607_DAC_B

#define LTC2607_DAC_B 0x01

Command (and DAC code) will modify DAC B.

Definition at line 162 of file LTC2607.h.

## ◆ LTC2607_I2C_ADDRESS

#define LTC2607_I2C_ADDRESS 0x10

I2C address of the LTC2607.

Configured with the CA0, CA1, and CA2 pins. See Table 1 of datasheet. Uncomment LTC2607_I2C_ADDRESS to match demo board configuration.

Definition at line 116 of file LTC2607.h.

## ◆ LTC2607_I2C_GLOBAL_ADDRESS

#define LTC2607_I2C_GLOBAL_ADDRESS 0x73

LTC2607 Global I2C Address.

Definition at line 145 of file LTC2607.h.

## ◆ LTC2607_POWER_DOWN_COMMAND

#define LTC2607_POWER_DOWN_COMMAND 0x40

Command to power down the LTC2607.

Definition at line 154 of file LTC2607.h.

## ◆ LTC2607_UPDATE_COMMAND

#define LTC2607_UPDATE_COMMAND 0x10

Command to update (and power up) LTC2607.

Output voltage will be set to the value stored in the internal register by previous write command.

Definition at line 152 of file LTC2607.h.

## ◆ LTC2607_WRITE_COMMAND

#define LTC2607_WRITE_COMMAND 0x00

Command to write to internal register of LTC2607, but not update output voltage yet.

Definition at line 151 of file LTC2607.h.

## ◆ LTC2607_WRITE_UPDATE_COMMAND

#define LTC2607_WRITE_UPDATE_COMMAND 0x30

Command to write and update (and power up) the LTC2607.

The output voltage will immediate change to the value being written to the internal register.

Definition at line 153 of file LTC2607.h.

## Variable Documentation

## ◆ LTC2607_TYPICAL_lsb

const float LTC2607_TYPICAL_lsb = 7.6295109E-5

The LTC2607 typical least significant bit value with 5V full-scale.

Definition at line 167 of file LTC2607.h.

## ◆ LTC2607_TYPICAL_OFFSET

const float LTC2607_TYPICAL_OFFSET = 0

The LTC2607 typical offset voltage.

Definition at line 168 of file LTC2607.h.